# -*- coding: utf-8 -*-
"""build list of reacheble lslinks.xml files
"""

from tools import logger, osutils
import tools.globals as G  # Globals of linkssorter
import lmglobals as GLM    # Globals of extension
import os.path
import xmlworker
import linkstructure

#import xmljobs

log = logger.getLogger()

def collectBrowseDirs(inputDirs = []):
    """Collect list of directories where links.xml files are expected"""
      
    log.info("Actual Dir %s  %s" % (os.path.abspath(os.curdir), inputDirs  ) )  
   
    if inputDirs == []:
       for directory in xmlworker.parseLSLinsksDirs(GLM.defaultDirsSerachFiles):
           inputDirs.append(directory)
     
    dirs = []    
    
    for directory in inputDirs:
        if os.path.isdir(directory):
           dirs.append(directory)
        else:
           log.warning("Directory [%s] defined as source of lslinsk.xml files was not found." % (directory))         

   
    log.info("%s", dirs)
    return dirs

def collectDataFiles(browseDirs = [], fileMasks = []):
    """walk thorough given directories and return list of lslinks.xml files
       don't care about duplicity
    """
    
    log.debug( "search in %s to subdirectories level %d" % (browseDirs, GLM.DefaultLevelsOfSearch )  )
  
    linksFiles = []

    # for every subdirectory level max by GE.DefaultLevelsOfSearch
    for i in range(GLM.DefaultLevelsOfSearch):
        filesOnLevel = osutils.listFilesOnLevel(rootDirs=browseDirs, fileMasks=fileMasks, level=i)
        # for every single - check if is not in list 
        for file in filesOnLevel:
            absFile = os.path.abspath(file)
            if absFile not in linksFiles:   # check duplicity
               linksFiles = linksFiles + [absFile]
            else: 
              pass
              log.info( "Duplicate file was kick out> %s" % (file)  )   
    
    linksFiles.sort()
    log.debug( "%s" % (linksFiles)  )
    return linksFiles

def buildLinksStructure(linksFiles):
    """ passing links files to pharser, collect references to links"""
    links = linkstructure.Links()

    #for every file with links configuration
    for file in linksFiles:
        newLinks = []
        newLinks = xmlworker.parseLinksFile(file)  #return links from it
       
        # for every link in links file
        for newLink in newLinks:
            links.addLink(newLink)            
            
        
    log.debug("No. links: %s", len(links.links)  )
    return links

def buildGroupsStructure(groupsFiles):
    """ passing groups files to pharser, collect references to groups"""
    groups = linkstructure.Groups()

    #for every file with groups configuration
    for file in groupsFiles:
        newGroups = []
        newGroups = xmlworker.parseGroupsFile(file)  #return groups from it
       
        # for every group in groups file
        for newGroup in newGroups:
            groups.addLink(newGroup)
              
    log.debug("No. groups: %s", len(groups.groups)  )
    return groups