# -*- coding: utf-8 -*-

from tools import logger
log = logger.getLogger()

class Link:
    """data cointainer for link"""    

    def __init__(self):
        """Structure for keepneng data of link"""
        log.debug("init NEW link")
        self.base = {}    # dictionary for saving parameters from lslinks.xml file 
        self.groups = []  # list contains classification of link

class Links:
    """keep references to links and encapsulate methods on links"""
    def __init__(self):
        log.debug("INIT NEW links structure")
        self.links = []
        self.listOfIds = []
  
    def addLink(self, link):
        """add link to structure, if it is not duplicit - resolved by id"""
        log.debug("")
        #check if it is not dulicit link
        if link.base['id'] not in self.listOfIds:
            self.links.append(link)
            self.listOfIds.append(link.base['id']) 
        else:
            log.warning("Duplicit link id: %s " % (link.base['id'])  )       
   
    def collectIDs(self):    
        """return list of indexes"""
        log.debug("%s", self.links)
        listOfId = []
       
        for link in self.links:
            listOfId.append(self.link.base[id])
        
        log.debug("No. IDs: %s", len(listOfId) )    
        return listOfId 
    
    def printNamesOfLinks(self):
        """print names of all links to the output"""  
        log.debug("")
        for link in self.links:
            print link.base['name'].encode("cp1250"), "   ", link.groups
            
class Group:
    """data cointainer for groups"""  

    def __init__(self):
        """Structure for keepneng data of link"""
        log.debug("init NEW group")
        self.base = {}    # dictionary for saving parameters from lslinks.xml file 
        self.groups = []  # list contains classification of link
        
class Groups:
    """keep references to groups"""      
    def __init__(self):
        log.debug("INIT NEW links structure")
        self.groups = []
        self.listOfNames = []
  
    def addLink(self, group):
        """add link to structure, if it is not duplicit - resolved by name"""
        log.debug("")
        #check if it is not dulicit
        if group.base['name'] not in self.listOfNames:
            self.groups.append(group)
            self.listOfNames.append(group.base['name']) 
        else:
            log.warning("Duplicit link id: %s " % (group.base['name'])  )
            
    def printNames(self):
        """print names of all groups to the output"""  
        log.debug("")
        for group in self.groups:
            print group.base['name'].encode("cp1250")
        
