# -*- coding: utf-8 -*-
""""help manipulate with os filesystem and directory tasks"""

import logger
import glob
import globals as G

import os
lexists = os.path.lexists

logger = logger.SetLogger(20)
log = logger.getLogger()

def listDirs(dirname):
    """Return list subdirectories in directory
    """
    subDirs = []

    for entry in os.listdir(dirname):
        item = os.path.normcase(os.path.join(dirname, entry))
        if os.path.isdir(item):
            subDirs.append(item)
 
    log.debug("---? %s" % (subDirs))
    return subDirs

def listDirsMulti(dirs=[]):
    """list subdirectories in multiple directories
    """
    
    subDirs = []
    
    for dir in dirs:
        subDirs = subDirs + (listDirs(dir))
    
    log.debug("---/---? %s" % (subDirs))    
    return subDirs

def listDirsOnlevel(rootDirs=['.'], level=0):
    """List subdirectories on some level depth in rootDirectory
    
    """
    log.debug("---<>---? %s %d" % (rootDirs, level)) 
    
    if level <= 0:
       return rootDirs
    else:   
       return listDirsOnlevel(listDirsMulti(rootDirs), level -1)
   
def listFilesOnLevel(rootDirs=['.'], fileMasks=['*.*',], level=0):
    """find and return files according to fileMasks in some subdirectory level of rootDirs
    """
    log.debug("---[---? %s  %s  %d" % (rootDirs, fileMasks, level))
    dirs = listDirsOnlevel(rootDirs, level)
    log.debug("---[]---? %s" % (dirs))
    files=[]
           
    for dir in dirs:
        for mask in fileMasks:
            matchFiles = glob.glob(os.path.join(dir,mask))
            log.debug("---[[]]---? MASK:%s FILES:%s" % (os.path.join(dir,mask), matchFiles))
            files.extend(matchFiles)
            
    return list(set(files))
        
def changeDestinationFile(oldDest, newDest):         
    """change filename in path to destF`ile"""
    if (oldDest == None) or (newDest == None) : return None
    log.debug("%s %s" % (oldDest, newDest))
    path = os.path.split(oldDest)
    return os.path.join(path[0], newDest) 

def absPathFromRealative(path):
    """Should return absolute path to file or directory from relative path to linkssorter"""
    log.debug("%s" % (path))          
    absPath = os.path.join(G.lsWorkingDir, path)
    print "-------->>> ", G.lsWorkingDir 
    print "-------->>> ", os.path.abspath(os.path.curdir)
    print "-------->>> ", absPath    
    log.debug("abs path %s" % (absPath))  

            